<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 31.30 - Lucky Dice</title>

    <!-- Nhúng thư viện boostrap -->
 <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
 <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
 <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>

</head>
<style>
    .cover-picture {
        background-image: url("LuckyDiceImages/cover.jpg");
        min-height: 120px;
        margin: 5px;
    }
</style>


<body>

<div class="containter-fluid cover-picture" > <!--Container 1-->
</div>
<br><br>
<div class="container"  > <!--Container 2-->
    <div class="row form-group">
        <div class="col-5 " > <!--User information-->
            <div class="row form-group">
                <h4><span style="color: green">Input your information</span></h4>
                <div class="col-12"> <!--Row 2.1.1.1.1-->

                </div> 
            </div>
            <div class="row form-group">
                <div class="col-4 "> <!--Row 2.1.1.2.1-->
                    <label>User name</label>
                </div>
                <div class="col-8 "> <!--Row 2.1.1.2.2 -->
                    <input id="inp-user-name" class="form-control" type="text">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-4 "> <!--Row 2.1.1.3.1-->
                    <label>Firstname</label></div>
                <div class="col-8 ">  <!--Row 2.1.1.3.2-->
                    <input id="inp-first-name" class="form-control" type="text">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-4 ">  <!--Row 2.1.1.4.1-->
                    <label>Lastname</label>
                </div>
                <div class="col-8 " > <!--Row 2.1.1.4.2-->
                    <input id="inp-last-name" class="form-control" type="text">
                </div>
            </div>
        </div>

        <div class="col-4 " > <!--Playing area-->
            <div class="col-12 text-center form-group "> <!--Row 2.1.2.1-->
                <button id="btn-play" class="btn btn-success" >Play</button>
            </div>
            <div class="col-12 form-group "> <!--Row 2.1.2.2-->
                <img id="img-dice" class="img-thumbnail" src="LuckyDiceImages/dice.png"></p>
            </div>
            <div class="col-12 form-group  text-center"> <!--Row 2.1.2.3-->
                <p id="p-notification-result"><b>Congratulation!!!</b></p>
            </div>
        </div>
        <div class="col-3 text-center "> <!--Present area-->
            <div class="row form-group">
                <div class="col-12 "> <!--Row 2.1.3.1-->
                    <p><span style="color: red"><b>Voucher</b></span></p>
                    <p id="p-voucher-id">No ID</p>
                    <p id="p-voucher-percent">0%</p>
                </div>
            </div>
            <div class="row form-group">
                <div class="col-12 "> <!--Row 2.1.3.2-->
                    <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/motobike.jpg">
                </div>
            </div>
            
        </div>
    </div>
</div>

<script>
/***REGION 1 - GLOBAL variables */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/";
    const vUTF8_TEXT_APPLICATION_HEADER = "application/json; charset=UTF-8";

    const gCOL_TURN = 0;
    const gCOL_DICE = 1;
    const gEND_OF_ROW_COL = -1;

/***REGION 2 - Element handlers */

/***REGION 3 - Event handlers */

    //data collection and validation
    function dataCollectValidate(){
        "use strict";
        //create user object
        var vUserObject = {
            user: "",
            firstname: "",
            lastname: "",

            displayConsoleLog() {
                console.log("%cUSER INFORMATION", "color:orange");
                console.log("Username: " + this.user);
                console.log("Firstname: " + this.firstname);
                console.log("Lastname: " + this.lastname);
            }
        }

        //read data from web form
        readDataWebForm(vUserObject);
        //validate the data
        var vValidResult = validDataWebForm(vUserObject);
        return vUserObject;
    }    

    //add event for Play button
    $("#btn-play").on('click', function(){
        var paramObject = dataCollectValidate();            
        //call API server for playing dice
        var vXmlHttp = new XMLHttpRequest();
        vXmlHttp.open("POST", gBASE_URL + "/dice", true);
        vXmlHttp.setRequestHeader("Content-Type", vUTF8_TEXT_APPLICATION_HEADER);
        vXmlHttp.send(JSON.stringify(paramObject));       
        vXmlHttp.onreadystatechange = function(){
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK){
                processReponse(vXmlHttp);
            }
        }
    })
    
        //function for processing JSON response
        function processReponse(paramResponse){
            console.log(paramResponse.responseText);
            //parsing JSON to object
            var vJsonResponseToObj = JSON.parse(paramResponse.responseText);
            console.log(vJsonResponseToObj)
            
            //display dice image on the web
            changeDice(vJsonResponseToObj);
            //display notification on the web
            changeNofitication(vJsonResponseToObj);
            //display voucher (if any)
            changeVoucher(vJsonResponseToObj);
            //display present (if any)
            changePresent(vJsonResponseToObj);
        }

        //function for displaying the result on the web
        function changeDice(paramDice){
            var vDiceImage = $('#img-dice')
            switch(paramDice.dice){
                case 1: 
                vDiceImage.attr('src', "LuckyDiceImages/1.png");
                break;

                case 2: 
                vDiceImage.attr('src', "LuckyDiceImages/2.png");
                break;

                case 3: 
                vDiceImage.attr('src', "LuckyDiceImages/3.png");
                break;

                case 4: 
                vDiceImage.attr('src', "LuckyDiceImages/4.png");
                break;

                case 5: 
                vDiceImage.attr('src', "LuckyDiceImages/5.png");
                break;

                default: 
                vDiceImage.attr('src', "LuckyDiceImages/6.png");
                break;
            }       
        }

        //function for displaying the notification
        function changeNofitication(paramDice){
            var vNotification = $("#p-notification-result")
            
            if (paramDice.dice <4) {
                vNotification.html("Wish you best luck next time - Please try another one!");
            }
            else {
                vNotification.html("Congratulation - Let try another one!");
            }
        }

        //function for displaying voucher (if any)
        function changeVoucher (paramDice){
            var vVoucher = $("#p-voucher-id");
            var vVoucherPercent = $("#p-voucher-percent");
            
            if (paramDice.voucher != null){
                vVoucher.html("Code: " + paramDice.voucher.maVoucher);
                vVoucherPercent.html("Sale OFF: " + paramDice.voucher.phanTramGiamGia + "%");
            } 
            else {
                vVoucher.html("");
                vVoucherPercent.html("");
            }
        }

        //function for displaying present (if any)
        function changePresent(paramDice){
            var vPresent = $("#img-present")

            switch(paramDice.prize){
                case  "Mũ":
                vPresent.attr('src', "LuckyDiceImages/hat.jpg")
                break;

                case "Ô tô":
                vPresent.attr('src', "LuckyDiceImages/car.jpg")
                break;

                case "Xe máy":
                vPresent.attr('src', "LuckyDiceImages/motobike.jpg")
                break;

                case "Áo":
                vPresent.attr('src', "LuckyDiceImages/t-shirt.jpg")
                break;


                default:
                vPresent.attr('src', "LuckyDiceImages/no-present.jpg")
                break;
            }
        }

        //function for reading data from the web form
        function readDataWebForm(paramData){

            var vUserElement = $('#inp-user-name').val();
            var vFirstNameElement = $("#inp-first-name").val();
            var vLastNameElement = $("#inp-last-name").val();

            paramData.user = vUserElement.trim();
            paramData.firstname = vFirstNameElement.trim();
            paramData.lastname = vLastNameElement.trim();
        }

        //function for validating the data
        function validDataWebForm(paramData){
        if (paramData.user ==""){
            alert("Please input your username");
            return false;
        }
        if (paramData.firstname ==""){
            alert("Please input your Firstname");
            return false;
        }
        if (paramData.lastname ==""){
            alert("Please input your Lastname");
            return false;
        }
        return true;
        }


   

/***REGION 4 - Common function */

</script>

</body>
</html>
